<%@ Page Language="vb" CodeFile="contadorapp.aspx.vb" Inherits="visitasform" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
    <title>Contador de visitas</title>
    <meta name="GENERATOR" content="Microsoft Visual Studio .NET 7.1">
    <meta name="CODE_LANGUAGE" content="Visual Basic .NET 7.1">
    <meta name="vs_defaultClientScript" content="JavaScript">
</head>
<body style="font-size: 10pt; font-family: verdana">
    <div align="center">
        <strong><font size="5">CONTADOR DE VISITAS<br>
        </font><font size="4">[usando web.config y variables de aplicacin]</font></strong>
        <p></p>
        <form id="Form1" method="post" runat="server">
            <p align="center">
                <asp:Label ID="n" runat="server" Font-Names="Verdana" ForeColor="Black" Font-Size="Small"></asp:Label>
                <br>
                <br>
                <b>Pulsa F5 para comprobar cmo aumenta el nmero de visitas.</b><br>
                <br>
            </p>
            <div style="width: 700px; text-align: left">
                <p>
                    Una aplicacin de ASP .NET es el conjunto de archivos y carpetas de un directorio virtual y se representa mediante el objeto HttpApplication. Un objeto de este tipo, llamado Application, es generado al arrancar la aplicacin (cuandoun cliente pide una pgina del sitio por primera vez).<br>
                    Application nos va a permitir guardar variables (variables de aplicacin) que van a estar disponibles para todos los usuarios (Application no asigna valores a usuarios concretos). Sin embargo, no es conveniente guardar en variables de aplicacin cdigo HTML extenso.
					La variable de aplicacin tiene una ventaja clara sobre la variable de sesinpor el hecho de ser creada una sola vez por aplicacin y no por usuario: independientemente del nmero de usuarios que visitan el sitio hay una sola variable, con el ahorro de memoria en el servidor.
                </p>
                <p><b>Qu es el archivo web.config?</b></p>
                <p>Archivo bsico de configuracin para toda aplicacin ASP. NET. En l, mediante etiquetado XML, se configura todo lo referente a seguridad, sesiones, compilacin, variables de sistema, etc. Web.config se coloca en el directorio raz de la aplicacin pero pueden existir ms dentro de las carpetas para dar configuraciones parciales para los distintos segmentos de las aplicaciones.</p>
                <p><b>Jerarqua de los archivos .config</b></p>
                <p>
                    .NET Framework se basa en archivos .config para definir opciones de configuracin. Los archivos .config son archivos XML basados en texto. En un nico sistema puede haber varios archivos .config.<br>
                    La opcin de configuracin para todo el sistema se define en el archivo Machine.config. que se localiza en la carpeta de instalacin de la versin correspondiente de .NET Framework. Machine.config se puede modificar para afectar al comportamiento de las aplicaciones .NET en todo el sistema.<br>
                    La configuracin de ASP.NET para una sola aplicacin se configura en un archivo Web.config que reside en la carpeta raz de la aplicacin. Web.config invalida la configuracin deMachine.config.
                </p>
                <p><b>Crear un archivo web.config</b></p>
                <p>
                    Se puede crear con un procesador de texto. Debe ser un documento XML con formato correcto y ha de residir en el directorio raz de su aplicacin ASP.NET. Como mnimo debe tener elementos &lt;configuration&gt; y &lt;system.web&gt; que contienen los elementos de configuracin individuales. Aqu se muestra un archivo Web.config mnimo:<br>
                    <pre style="font-family: Verdana; font-size: 10pt;">
&lt;?xml version="1.0" encoding="utf-8" ?&gt;
&lt;configuration&gt;

	&lt;appSettings&gt;
		...
	&lt;/appSettings&gt;

	&lt;system.web&gt;
		...
	&lt;/system.web&gt;

&lt;/configuration&gt;</pre>
                    <p>
                        La primera lnea del archivo Web.config describe el documento XML y es la misma para todos los archivos .config. Las lneas que siguen marcan el principio y el fin de los elementos &lt;configuration&gt; y &lt;system.web&gt;. En ellos se van aadiendo las diferentes opciones de configuracin.<br>
                        Cada vez que se modifica algo en Web.config, que es controlado por el CLR de .NET Framework, se reinicia la aplicacin web.<br>
                        En la seccin appSettings podemos configurar variables del tipo clave / valor y utilizarlas en la aplicacin.<br>
                        Viendo las diferentes secciones con algo ms de detalle, podramos tener este Web.config:
                    </p>
                <pre style="font-family: Verdana; font-size: 10pt;">
&lt;?xml version="1.0" encoding="utf-8" ?&gt;
&lt;configuration&gt;

	&lt;configSections&gt;
	
	&lt;/configSections&gt;

	&lt;!--Seccin de variables que se pueden usar en toda la aplicacin.--&gt;
	&lt;appSettings&gt;
		&lt;add key="nombre1" value="valor1" /&gt;
		&lt;add key="nombre2" value="valor2" /&gt;
	&lt;/appSettings&gt;

	&lt;system.web&gt;
		&lt;!--Configuracin de las sesiones--&gt;
		&lt;sessionState timeout="60" /&gt;
		&lt;!--Habilitando y estableciendo duracin de las cookies--&gt;
		&lt;sessionState cookieless="true" timeout="10"/&gt;
	&lt;/system.web&gt;

&lt;/configuration&gt;</pre>
                <p>En l se han creado 2 variables cuyos valores podremos obtener desde el cdigo aspx.vb y otras opciones referentes a la duracin de las sesiones o de las cookies.</p>
                <p>
                    Para acceder a las variables desde el cdigo aspx.vb se pueden emplear 2 construcciones;<br>
                    <br>
                    <em>System.Configuration.ConfigurationSettings.AppSettings("nombre1")</em><br>
                    <em>System.Web.Configuration.WebConfigurationManager.AppSettings("nombre2")<br>
                    </em>
                    <br>
                    <br>
            </div>
        </form>
    </div>
</body>
</html>
